#include <boost/unordered_map.hpp>
#include <getopt.h>
#include <iostream>
#include <sstream>
#include <fstream>

using namespace std;
using namespace boost;

typedef unordered_map< int, unordered_map<int, bool> > Graph;
int last = 0;

Graph read_graph(const char *file) {
  Graph G;
  ifstream input(file, ifstream::in);
  string line;
  int cur = 1;

  getline(input, line);
  getline(input, line);

  while(input.good()) {
    if(line[0] == '#') {
      getline(input, line);
      continue;
    }
    istringstream linestream(line);
    int x;
    while(linestream >> x) {
      G[cur][x] = true;
      G[x][cur] = true;
    }
    getline(input, line);
    cur++;
  }
  return G;
}

void usage(const char*) {}

void get_triangles(Graph& G) {
  for(Graph::iterator i = G.begin(); i != G.end(); ++i)
    for(Graph::iterator j = i; j != G.end(); ++j)
      for(Graph::iterator k = j; k != G.end(); ++k)
	if(i != j && j != k && k != i) {
	  int sum = G[i->first][j->first] + G[j->first][k->first] +
	    G[k->first][i->first];
	  if(sum == 2)
	    cout << i->first << " " << j->first
		 << " " << k->first << endl;
	}
}

int main(int argc, char *argv[]) {
  int c;
  while((c=getopt(argc, argv, "")) != -1)
    switch (c) {
    default: usage(argv[0]);
    }
  
  if(optind >= argc) {
    cout << "Error: no filename given" << endl;
    usage(argv[0]);
  }

  Graph G(read_graph(argv[optind]));
  get_triangles(G);
  return 0;
}
