#include <getopt.h>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <iterator>
#include <list>
using namespace std;

int main(int argc, char *argv[]) {
  int n = 0;
  int m = 0;
  int a = 0;

  srand(time(NULL));

  if(argc!=4) {
    cerr << "Usage: " << argv[0] << " numverts numedges avgedgesize" << endl;
  } else {
    n = atoi(argv[1]);
    m = atoi(argv[2]);
    a = atoi(argv[3]);
    cerr << "Generating hypergraph with " << n << " vertices, " << m << " hyperedges, and avg. edgesize " << a << endl;
  }

  for(int edge = 1; edge <= m; ++edge) {
    list<int> edgelist;
    for(int vert = 0; vert < n; ++vert)
      if(rand() <= (double)((double)a/(double)n)*RAND_MAX)
	edgelist.push_back(vert);
    if(edgelist.size() >= 2) {
      copy(edgelist.begin(), edgelist.end(), ostream_iterator<int>(cout, " "));
      cout << endl;
    } else --edge;
  }
}
